# 1 "../../core/lib/list.c"
# 1 "/opt/contiki-2.x/examples/hello-world//"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "../../core/lib/list.c"
# 48 "../../core/lib/list.c"
# 1 "../../core/./lib/list.h" 1
# 97 "../../core/./lib/list.h"
typedef void ** list_t;

void list_init(list_t list);
void * list_head(list_t list);
void * list_tail(list_t list);
void * list_pop (list_t list);
void list_push(list_t list, void *item);

void * list_chop(list_t list);

void list_add(list_t list, void *item);
void list_remove(list_t list, void *item);

int list_length(list_t list);

void list_copy(list_t dest, list_t src);

void list_insert(list_t list, void *previtem, void *newitem);
# 49 "../../core/lib/list.c" 2



struct list {
  struct list *next;
};
# 65 "../../core/lib/list.c"
void
list_init(list_t list)
{
  *list = 0;
}
# 82 "../../core/lib/list.c"
void *
list_head(list_t list)
{
  return *list;
}
# 100 "../../core/lib/list.c"
void
list_copy(list_t dest, list_t src)
{
  *dest = *src;
}
# 117 "../../core/lib/list.c"
void *
list_tail(list_t list)
{
  struct list *l;

  if(*list == 0) {
    return 0;
  }

  for(l = *list; l->next != 0; l = l->next);

  return l;
}
# 142 "../../core/lib/list.c"
void
list_add(list_t list, void *item)
{
  struct list *l;

  ((struct list *)item)->next = 0;

  l = list_tail(list);

  if(l == 0) {
    *list = item;
  } else {
    l->next = item;
  }
}




void
list_push(list_t list, void *item)
{


  ((struct list *)item)->next = *list;
  *list = item;
}
# 179 "../../core/lib/list.c"
void *
list_chop(list_t list)
{
  struct list *l, *r;

  if(*list == 0) {
    return 0;
  }
  if(((struct list *)*list)->next == 0) {
    l = *list;
    *list = 0;
    return l;
  }

  for(l = *list; l->next->next != 0; l = l->next);

  r = l->next;
  l->next = 0;

  return r;
}
# 211 "../../core/lib/list.c"
void *
list_pop(list_t list)
{
  struct list *l;
  l = *list;
  if(*list != 0) {
    *list = ((struct list *)*list)->next;
  }

  return l;
}
# 233 "../../core/lib/list.c"
void
list_remove(list_t list, void *item)
{
  struct list *l, *r;

  if(*list == 0) {
    return;
  }

  r = 0;
  for(l = *list; l != 0; l = l->next) {
    if(l == item) {
      if(r == 0) {

 *list = l->next;
      } else {

 r->next = l->next;
      }
      l->next = 0;
      return;
    }
    r = l;
  }
}
# 268 "../../core/lib/list.c"
int
list_length(list_t list)
{
  struct list *l;
  int n = 0;

  for(l = *list; l != 0; l = l->next) {
    ++n;
  }

  return n;
}
# 296 "../../core/lib/list.c"
void
list_insert(list_t list, void *previtem, void *newitem)
{
  if(previtem == 0) {
    list_push(list, newitem);
  } else {

    ((struct list *)newitem)->next = ((struct list *)previtem)->next;
    ((struct list *)previtem)->next = newitem;
  }
}
