
#include "contiki.h"
#include "contiki-net.h"
#include "dev/serial-line.h"
#include "net/rime.h"
#include "dev/leds.h"
#include <stdio.h>

/*---------------------------------------------------------------------------*/
PROCESS(mosend_process, "Motor Sender");
AUTOSTART_PROCESSES(&mosend_process);


static void
recv(struct abc_conn *c)
{
  //do nothing
}
static struct abc_callbacks abc_call = {recv};
static struct abc_conn abc;

void send_command(char*,int);

PROCESS_THREAD(mosend_process, ev, data)
{
  PROCESS_BEGIN();
  
  abc_open(&abc,11,&abc_call);
  
  while(1) {    
    PROCESS_WAIT_EVENT_UNTIL(ev == serial_line_event_message && data != NULL);
    send_command(data, strlen(data));
  }
  PROCESS_END();

}

void send_command(char* data, int len){
  if(data[0] == 'm' && data[1] == 'o' && data[len-1] == '%'){
    leds_toggle(LEDS_GREEN);
    packetbuf_clear();
    packetbuf_copyfrom(data,strlen(data));
    abc_send(&abc);
  }
}
