//Simple packet sniffer
//Andrew Pullin, BMI 2007

#include "contiki.h"
#include "dev/leds.h"
#include <string.h>
#include <stdio.h>
#include "net/rime.h"
#include "dev/cc2420.h"
#include "dev/button-sensor.h"
#include "dev/radio.h"


unsigned int rfchan = 15;
/*---------------------------------------------------------------------------*/
PROCESS(radio_sniffer_process, "Sniffer");
AUTOSTART_PROCESSES(&radio_sniffer_process);
/*---------------------------------------------------------------------------*/

static void
sniffer_callback(const struct radio_driver *d)
{
  int i=0;
  static u8_t packet[128];
  static int len;
  
  len = d->read(packet, sizeof(packet));
  printf("l=%d : ",len);
  
  for(i=0;i < len; i++)
    {
      printf("%02x ",*((u8_t*)(packet)+i));
    }
    printf("    RSSI: %i \n",cc2420_last_rssi);
}


PROCESS_THREAD(radio_sniffer_process, ev, data)
{
   PROCESS_BEGIN();

   //PROCESS_PAUSE(); /* This may be needed to let the system initialize itself. */

   //cc2420_on();
   printf("Starting sniffer on channel %d (%d)\n",rfchan,rfchan+11);
   cc2420_set_channel(rfchan+11);

   cc2420_driver.set_receive_function(sniffer_callback);
   
   
   while(1) {
     PROCESS_WAIT_EVENT_UNTIL(ev == sensors_event &&
			      data == &button_sensor);
     rfchan++;
     rfchan &= 15;
     printf("Switching to RF channel %d (%d)\n",rfchan,rfchan+11);
     //cc2420_off();
     cc2420_set_channel(rfchan+11);
     //cc2420_on();
     leds_toggle(LEDS_ALL); 
   }

   PROCESS_END();
}
